
set echo on

CREATE TYPE employees_ot AS OBJECT
( employee_id    NUMBER(6)
, first_name     VARCHAR2(20)
, last_name      VARCHAR2(25)
, email          VARCHAR2(25)
, phone_number   VARCHAR2(20)
, hire_date      DATE
, job_id         VARCHAR2(10)
, salary         NUMBER(8,2)
, commission_pct NUMBER(2,2)
, manager_id     NUMBER(6)
, department_id  NUMBER(4)
);
/

CREATE TYPE employees_ntt AS TABLE OF employees_ot;
/

CREATE FUNCTION employees_piped 
   RETURN employees_ntt PIPELINED AS
BEGIN
   FOR r IN (SELECT * FROM employees) LOOP
      FOR i IN 1 .. 200 LOOP
         PIPE ROW (employees_ot(
                      r.employee_id, r.first_name, r.last_name,
                      r.email, r.phone_number, r.hire_date,
                      r.job_id, r.salary, r.commission_pct,
                      r.manager_id, r.department_id));
      END LOOP;
   END LOOP;
   RETURN;
END employees_piped;
/

SELECT COUNT(*)
FROM   TABLE(employees_piped);

